file_id = "ARDUINO_IO_PUT"
log_msg("start..",file_id)

--[[
**************************************************************************************
Arduino デバイスの指定したI/O ポートの値を設定する

スクリプト起動時に渡されるパラメータ
---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------
port			Arduino port 番号										"1"

value			I/O ポートに設定する値(16進数2桁)						"FC"

ATmega328 を使用した Arduino ボードの場合には、 digital I/O port は 0,1 の2 つで
それぞれ、port0:PORTD, port1:PORTB(bit#0-bit#5) + (PORTC bit#0-#1)に対応しています。
詳しくは、Arduino IDE に同梱されている pins_arduino.h ファイルを参照して下さい。
**************************************************************************************
]]

-------------------------
-- パラメータチェック
-------------------------
if not (g_params["port"] and g_params["value"]) then
	log_msg("parameter error",file_id)
	error()
end

----------------------------------------------------------------------
-- Firmata digital I/O message 送信
----------------------------------------------------------------------
local com = "COM4"
local firmata_command = list_to_hex(bit_or(0x90,tonumber(g_params["port"])))
local send_data = firmata_command .. tbl_to_hex72({tonumber("0x" .. g_params["value"])},2)
local stat,rdata = serial_write(com,send_data)
if not stat then
	log_msg("serial_write() failed",file_id)
	error()
end

