file_id = "ARDUINO_PIN_SET"
log_msg("start..",file_id)

--[[
**************************************************************************************
Arduino デバイスの指定したI/O ピンの値を設定する

スクリプト起動時に渡されるパラメータ
---------------------------------------------------------------------------------
キー値			値		            									値の例
---------------------------------------------------------------------------------
pin			Arduino pin番号(2 から 13 までの整数)						"13"

value		pin に指定したI/Oポートに設定する値(0 または 1)				"1"

**************************************************************************************
]]

-------------------------
-- パラメータチェック
-------------------------
if not (g_params["pin"] and g_params["value"]) then
	log_msg("parameter error",file_id)
	error()
end

----------------------------------------------------------------------
-- Arduino digital I/O ポート取得 QUERY 送信と REPLY 受信
----------------------------------------------------------------------
local com = "COM4"
local sysex_start = "F0"
local sysex_end = "F7"
local firmata_request = "63"
local pin = bit_tohex(tonumber(g_params["pin"]),2) 
local val = bit_tohex(tonumber(g_params["value"]),2) 
local send_data = sysex_start .. firmata_request .. pin .. val .. sysex_end

----------------------------------------------------------------------
-- リクエストフレーム送信
----------------------------------------------------------------------
local stat = serial_write(com,send_data)
if not stat then
	log_msg("serial_write() failed",file_id)
	error()
end

