
// 	Webサーバーから、別のPC で実行中の DeviceServerにアクセスする場合の
//	URLホスト名とポート番号部分を設定する
//
//  DeviceServer 自身の HTTP サーバー機能を使用している場合には "" にする
//
//var server_host_url = "http://your_DeviceServer_public_url:80";
var server_host_url = "";

// DeviceServer セッション認証用トークン文字列
var session_token = "";

// DeviceServer の LogService にログメッセージを出力する
function log(msg,module){
	var url = server_host_url + "/command/log?message=";
	url = url + encodeURIComponent(msg);
	if (module != undefined){
		url = url + "&module=" + encodeURIComponent(module);
	}
	$.get(url,"",function(data){},"text");
}

// DeviceServer のスクリプトを実行する。
// 第２パラメータにスクリプトパラメータを指定する
// callback パラメータを省略するとリターンパラメータを受け取らない
function script_exec(name,params,callback){
	if (callback == undefined){
		var callback = "default_callback";
    	var url = 	server_host_url + "/command/json/script" +
					"?session=" + encodeURIComponent(session_token) +
					"&resultrecords=0" +
					"&name=" + encodeURIComponent(name);
	} else {
    	var url = 	server_host_url + "/command/json/script" +
					"?session=" + encodeURIComponent(session_token) +
					"&name=" + encodeURIComponent(name);
	}

	for(key in params){
		url = url + "&" + encodeURIComponent(key) + "=" + encodeURIComponent(params[key]);
	}

	$.ajax({"url" : url,
			"dataType" : "jsonp",
			"jsonpCallback" : callback
	});
}

// script_exec() でコールバックを指定しない場合のデフォルトコールバック関数
function default_callback(data){
	if (data.Result != "Success"){
		log("*ERROR* script error!");
		return;
	} 
}

// スクリプト実行結果ステータスのみをチェック
function script_exec_callback(data){
	if (data.Result != "Success"){
		$.mobile.changePage( "#error_back_dialog", {transition: "pop",role:"dialog"}); 
	} 
}

// スクリプト実行結果ステータスチェックとUI 値リロード
function script_exec_callback_reload(data){
	if (data.Result != "Success"){
		$.mobile.changePage( "#error_back_dialog", {transition: "pop",role:"dialog"}); 
	}
	load_arduino_io();
}

// UI コンポーネントの xml 属性値を検索取得
function getAttrVal(node,name){
	var val = "";
	var attr =  node.attributes;
	for (var i=0; i<attr.length; i++){
		if (attr[i].nodeName == name){
			val = attr[i].nodeValue;
		}
	}
	return val;
}

// IO ポート値の配列を受け取ってチェックボックスの値に反映させる
// パラメータフォーマット {"PORT_0":"xx","PORT_1":"xx"}
function apply_ui(ports){
	var pval;
	var	flag;

	if (ports.PORT_0 != ""){
		pval = parseInt(ports.PORT_0,16);

		flag = ((pval & (1 << 2)) != 0);
		if ($("#checkbox1").checked != flag) $("#checkbox1").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 3)) != 0);
		if ($("#checkbox2").checked != flag) $("#checkbox2").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 4)) != 0);
		if ($("#checkbox3").checked != flag) $("#checkbox3").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 5)) != 0);
		if ($("#checkbox4").checked != flag) $("#checkbox4").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 6)) != 0);
		if ($("#checkbox5").checked != flag) $("#checkbox5").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 7)) != 0);
		if ($("#checkbox6").checked != flag) $("#checkbox6").attr("checked",flag).checkboxradio("refresh");

	}

	if (ports.PORT_1 != ""){
		pval = parseInt(ports.PORT_1,16);

		flag = ((pval & (1 << 0)) != 0);
		if ($("#checkbox7").checked != flag) $("#checkbox7").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 1)) != 0);
		if ($("#checkbox8").checked != flag) $("#checkbox8").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 2)) != 0);
		if ($("#checkbox9").checked != flag) $("#checkbox9").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 3)) != 0);
		if ($("#checkbox10").checked != flag) $("#checkbox10").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 4)) != 0);
		if ($("#checkbox11").checked != flag) $("#checkbox11").attr("checked",flag).checkboxradio("refresh");
		flag = ((pval & (1 << 5)) != 0);
		if ($("#checkbox12").checked != flag) $("#checkbox12").attr("checked",flag).checkboxradio("refresh");

	}
}


// ARDUINO_IO_GET スクリプト実行結果のイベントハンドラ。
function io_get_handler(data){
	if (data.Result != "Success"){
		$.mobile.changePage( "#error_back_dialog", {transition: "pop",role:"dialog"});
		return;
	}
	apply_ui(data.ResultParams);
}


// UI コンポーネントの初期値ロード
function load_arduino_io(){
	script_exec("ARDUINO_IO_GET",{},"io_get_handler");
}

// メインページが表示された
$( '#page1' ).live( 'pageshow',function(event){
	// 秘密のセッショントークン文字列を強制的に設定
	session_token = "abc123";

	load_arduino_io();
});

// チェックボックスを操作してArduino ピンの値が更新された
$('input[class="pin"]' ).bind( "change", function(event, ui){
	var params = {};
	var attrVal = getAttrVal(this,"pin");
	if (attrVal != ""){
		params["pin"] = attrVal;
		if (this.checked){
			params["value"] = "1";
		} else {
			params["value"] = "0";
		}
		script_exec("ARDUINO_PIN_SET",params,"script_exec_callback");
	}
});

// ボタンを操作してArduino ポートの値がクリアされた
$('[class="port"]' ).bind( "click", function(event, ui){
	var params = {};
	var attrVal = getAttrVal(this,"port");
	if (attrVal != ""){
		params["value"] = "00";
		params["port"] = attrVal;
		script_exec("ARDUINO_IO_PUT",params,"script_exec_callback_reload");
	}
});


// Arduino の I/O 状態が変更された場合に最新のI/O データが配信されてくる
// これを受信するために、WebSocket(socket.io)でリレーサーバーに接続する
var socket = io.connect('/',{ port:9090});

// リレーサーバーから 'broadcast' タグの付いたメッセージを受信した
socket.on('broadcast', function (data) {
	// 配信されてきたJSON データを取得
	// JSON 文字列からオブジェクトにデコード
	// イベントハンドラのパラメータ data 自身もオブジェクトだが、その中の
	// message タグに格納されているのは、ただの JSON 文字列になっている点に注意
	var obj = $.parseJSON(data["message"]);

	// 最新の I/Oデータをチェックボックスに反映させる
	apply_ui(obj);
});


